package com.winhc.bigdata.flink

import com.winhc.bigdata.flink.func.HbaseAsyncFunction
import com.winhc.bigdata.flink.source.OdpsSourceBuilder
import org.apache.flink.api.scala._
import org.apache.flink.streaming.api.functions.sink.PrintSinkFunction
import org.apache.flink.streaming.api.scala.async.AsyncFunction
import org.apache.flink.streaming.api.scala.{AsyncDataStream, DataStream, StreamExecutionEnvironment}
import org.apache.flink.table.data.RowData

import java.util.concurrent.TimeUnit

/**
 * @author: XuJiakai
 * @date: 2021/8/30 14:32
 */
object TestJob {

  def test1(): Unit = {
    val env = StreamExecutionEnvironment.getExecutionEnvironment

    val odpsSource = OdpsSourceBuilder.buildSourceFunction("winhc_ng.xjk_test_test")
    val source = env.addSource[RowData](odpsSource)
    source.addSink(new PrintSinkFunction[RowData])
    env.execute("test job")
  }

  def test2(): Unit = {
    val env = StreamExecutionEnvironment.getExecutionEnvironment
    val odpsSource = OdpsSourceBuilder.buildSourceFunction(tableName = "winhc_ng.xjk_test_flink_ads_company", partition = "ds=20210803")
    val source = env.addSource[RowData](odpsSource)
    val value1: DataStream[(String, String)] = source.map(r => ("ng_company", r.getString(0).toString))
    val function: AsyncFunction[(String, String), (String, String, String)] = HbaseAsyncFunction()
    val value: DataStream[(String, String, String)] = AsyncDataStream.unorderedWait(value1, function, 100, TimeUnit.SECONDS, 10)

    value.addSink(new PrintSinkFunction[(String, String, String)])
    env.execute("test job")
  }


  def main(args: Array[String]): Unit = {
    test2()
  }
}
