package com.winhc.bigdata.flink.func

import com.alibaba.fastjson.JSONObject
import com.winhc.bigdata.flink.config.HbaseConfig
import org.apache.flink.configuration.Configuration
import org.apache.flink.runtime.state.{FunctionInitializationContext, FunctionSnapshotContext}
import org.apache.flink.streaming.api.checkpoint.CheckpointedFunction
import org.apache.flink.streaming.api.functions.sink.{RichSinkFunction, SinkFunction}
import org.apache.hadoop.hbase.client.{BufferedMutator, Connection, ConnectionFactory, RetriesExhaustedWithDetailsException}

/**
 * @author: XuJiakai
 * @date: 2021/9/1 17:52
 */
case class HbaseSinkFunction(tableName:String,jsonObject:JSONObject) extends RichSinkFunction[JSONObject] with CheckpointedFunction with BufferedMutator.ExceptionListener {
  var connection: Connection = null

  override def open(parameters: Configuration): Unit = {
    val configuration = HbaseConfig.getHbaseConfiguration()
    connection = ConnectionFactory.createConnection(configuration)
  }


  override def invoke(value: JSONObject, context: SinkFunction.Context): Unit = {

  }

  override def close(): Unit = {
    if (connection != null) {
      connection.close()
    }
  }

  override def snapshotState(context: FunctionSnapshotContext): Unit = ???

  override def initializeState(context: FunctionInitializationContext): Unit = ???

  override def onException(e: RetriesExhaustedWithDetailsException, bufferedMutator: BufferedMutator): Unit = ???
}
