package com.winhc.bigdata.flink.jobs

import com.winhc.bigdata.flink.jobs.company_job_step._
import com.winhc.bigdata.flink.source.KafkaSourceBuilder
import org.apache.flink.api.scala._
import org.apache.flink.streaming.api.scala.{DataStream, StreamExecutionEnvironment}

/**
 * @author: XuJiakai
 * @date: 2021/9/1 11:34
 */
object CompanyStreamJob {

  def main(args: Array[String]): Unit = {
    val env = StreamExecutionEnvironment.getExecutionEnvironment
    val kafkaSource = KafkaSourceBuilder.buildSourceFunction("xjk_test_topic")
    val source: DataStream[String] = env.fromSource[String](kafkaSource, CustomWatermarkStrategy(), "Kafka Source")
    source.winhcTransform()

    env.execute("CompanyStreamJob")
  }
}
